
import javax.swing.*;
import javax.swing.table.*;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.Dimension;

public class TebleEx 
{
	private JFrame frame;
    private TableModel dataModel;
    public TebleEx() 
	{
	frame = new JFrame("Table");
	frame.addWindowListener(new WindowAdapter() {
	    public void windowClosing(WindowEvent e) {System.exit(0);}});

	// Take the dummy data from SwingSet.
	final String[] names = {"Symbol","Name","Value","Difference","%Difference"};
	final Object[][] data = GetObjectData();
	// Create a model of the data.
	dataModel = new AbstractTableModel() 
		{
		// These methods always need to be implemented.
		public int getColumnCount() { return names.length; }
	    public int getRowCount() { return data.length;}
		public Object getValueAt(int row, int col) {return data[row][col];}

		// The default implementations of these methods in
		// AbstractTableModel would work, but we can refine them.
		public String getColumnName(int column) {return names[column];}
		public Class getColumnClass(int col) {return getValueAt(0,col).getClass();}
		public boolean isCellEditable(int row, int col) {return (col==4);}
		public void setValueAt(Object aValue, int row, int column) {
		 data[row][column] = aValue;
		}
	};

	// Instead of making the table display the data as it would normally with:
	// JTable tableView = new JTable(dataModel);
	// Add a sorter, by using the following three lines instead of the one above.
	TableSorter  sorter = new TableSorter(dataModel);
	JTable    tableView = new JTable(sorter);
	sorter.addMouseListenerToHeaderInTable(tableView);

	JScrollPane scrollpane = new JScrollPane(tableView);

	scrollpane.setPreferredSize(new Dimension(800, 200));
	frame.getContentPane().add(scrollpane);
	frame.pack();
	frame.setVisible(true);
        dataModel.setValueAt(new Integer(100),1,1);

	}
    Object[][] GetObjectData()
    {
	final Object[][] data ={ 
                {"IBM", "IBM",new Float(0.00),new Float(0.00),new Float(0.00)},
                {"DEC", "DIGITAL EQUIPMENT CORPORATION",new Float(0.00),new Float(0.00),new Float(0.00)},
                {"HP", "Hewlett Packard", new Float(0.00),new Float(0.00),new Float(0.00)},
                {"SUN", "Sun MicroSystems",new Float(0.00),new Float(0.00),new Float(0.00)},
                {"SCO", "SCO Systems",new Float(0.00),new Float(0.00),new Float(0.00)}
	};
	 return data;
        }
    public Object GetValueAtRowCol(int Row,int Col)
	{
                return dataModel.getValueAt(Row,Col);
	 }

    public void SetValueAtRowCol(Object ob,int Row,int Col)
	{
//	Float val1 =new Float( ob.getFloat() - GetValueAtRowCol(Row,Col).getFloat());
		dataModel.setValueAt(ob,Row,Col+1);
//		dataModel.setValueAt(val1,Row,Col+1);
//		dataModel.setValueAt(new Float(val1/100),Row,Col+2);
                
                frame.repaint();
	 }
	
    
}
